// Generated by CoffeeScript 1.12.7
(function() {
  var ceri;

  ceri = require("ceri/lib/wrapper");

  module.exports = ceri({
    mixins: [require("ceri/lib/props"), require("ceri/lib/computed"), require("ceri/lib/style"), require("ceri/lib/animate"), require("ceri/lib/open"), require("ceri/lib/getViewportSize"), require("ceri/lib/getScrollPos")],
    props: {
      anchor: {
        type: String
      },
      delayHover: {
        type: Number,
        "default": 400
      },
      delayTouch: {
        type: Number,
        "default": 200
      },
      onBody: {
        type: Boolean
      }
    },
    initStyle: {
      position: "absolute",
      display: "block"
    },
    events: {
      mouseover: {
        target: {
          active: function() {
            return !this.openingOrOpen;
          },
          cbs: "show",
          defer: {
            cancel: ["mouseleave", "click"],
            delay: "delayHover"
          },
          destroy: true
        }
      },
      click: {
        target: {
          active: "openingOrOpen",
          cbs: "hide",
          destroy: true
        }
      },
      mouseleave: {
        target: {
          active: "openingOrOpen",
          cbs: "hide",
          destroy: true
        }
      },
      touchstart: {
        target: {
          active: function() {
            return !this.openingOrOpen;
          },
          cbs: function() {
            return this.touched = setTimeout(this.show.bind(this), this.delayTouch);
          },
          destroy: true
        }
      },
      touchmove: {
        body: {
          el: document.body,
          active: "touched",
          cbs: function() {
            clearTimeout(this.touched);
            return this.touched = false;
          },
          stop: true,
          destroy: true
        }
      },
      touchend: {
        body: {
          el: document.body,
          active: function() {
            return this.touched || this.openingOrOpen;
          },
          cbs: function() {
            clearTimeout(this.touched);
            this.touched = false;
            return this.hide();
          },
          destroy: true
        }
      }
    },
    data: function() {
      return {
        touched: false
      };
    },
    computed: {
      target: function() {
        if (this.__placeholder.previousElementSibling) {
          return this.__placeholder.previousElementSibling;
        } else {
          return this.__parentElement;
        }
      },
      cAnchor: function() {
        var windowSize;
        if (this.anchor) {
          return this.anchor;
        }
        windowSize = this.getViewportSize();
        if (windowSize.width < 992) {
          return "wnse";
        }
        return "senw";
      }
    },
    methods: {
      enter: function(o) {
        o.preserve = ["overflow"];
        o.init = {
          overflow: "hidden",
          top: this.top + "px",
          left: this.left + "px"
        };
        o.duration = 150;
        o.style = {
          opacity: [0, 1]
        };
        switch (this.direction) {
          case "s":
            o.style.translateY = [-this.offsetTop, 0, "px"];
            break;
          case "n":
            o.style.translateY = [this.offsetTop, 0, "px"];
            break;
          case "e":
            o.style.translateX = [-this.offsetLeft, 0, "px"];
            break;
          case "w":
            o.style.translateX = [this.offsetLeft, 0, "px"];
        }
        return this.$animate(o);
      },
      leave: function(o) {
        o.preserve = ["overflow"];
        o.init = {
          overflow: "hidden"
        };
        o.duration = 150;
        o.style = {
          opacity: [1, 0]
        };
        return this.$animate(o);
      },
      onShow: function() {
        var a, height, i, isPositioned, left, len, parentHeight, parentStyle, parentWidth, pos, ref, scroll, targetPos, top, width, windowSize;
        targetPos = this.target.getBoundingClientRect();
        windowSize = this.getViewportSize();
        this.style.top = 0;
        this.style.left = 0;
        height = this.offsetHeight + this.offsetTop;
        width = this.offsetWidth + this.offsetLeft;
        pos = null;
        ref = this.cAnchor;
        for (i = 0, len = ref.length; i < len; i++) {
          a = ref[i];
          pos = a;
          if (a === "w" && targetPos.left - width >= 0) {
            break;
          } else if (a === "n" && targetPos.top - height >= 0) {
            break;
          } else if (a === "s" && targetPos.bottom + height <= windowSize.height) {
            break;
          } else if (a === "e" && targetPos.right + width <= windowSize.width) {
            break;
          }
        }
        this.direction = pos;
        parentHeight = targetPos.height;
        parentWidth = targetPos.width;
        width += this.offsetLeft;
        height += this.offsetTop;
        if (pos === "s") {
          top = parentHeight;
          left = parentWidth / 2 - width / 2;
        } else if (pos === "n") {
          top = -height;
          left = parentWidth / 2 - width / 2;
        } else if (pos === "w") {
          top = parentHeight / 2 - height / 2;
          left = -width;
        } else if (pos === "e") {
          top = parentHeight / 2 - height / 2;
          left = parentWidth;
        }
        if (this.onBody) {
          scroll = this.getScrollPos();
          top += scroll.top + targetPos.top;
          left += scroll.left + targetPos.left;
        } else {
          parentStyle = getComputedStyle(this.parentElement);
          isPositioned = /relative|absolute|fixed/.test(parentStyle.getPropertyValue("position"));
          if (this.parentElement === this.target && isPositioned) {
            left -= parseInt(parentStyle.getPropertyValue("border-left-width"));
            top -= parseInt(parentStyle.getPropertyValue("border-top-width"));
          } else {
            top += this.target.offsetTop;
            left += this.target.offsetLeft;
          }
        }
        this.top = top;
        return this.left = left;
      }
    }
  });

}).call(this);
